## libtgowt 0~git20230615.a45d8b8%2Bdfsg

=== debian/changelog ===
libtgowt (0~git20230615.a45d8b8+dfsg-2) unstable; urgency=medium

  * New Unbundle-libyuv.patch and libyuv-dev build dependency.
    - This should fix final linking on RISC-V 64bit.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 24 Jun 2023 17:21:00 +0300

libtgowt (0~git20230615.a45d8b8+dfsg-1) unstable; urgency=medium

  * Update to the latest upstream commit.
  * Exclude libSRTP from the orig tarball.
  * Bring back Ignore-sanitize-attr.patch to fix RISC-V 64bit build.
  * Remove outdated Packaged-PipeWire.patch which is no longer needed.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Tue, 20 Jun 2023 23:15:09 +0300

libtgowt (0~git20230105.5098730+dfsg-2) unstable; urgency=medium

  * New Unbundle-libSRTP.patch.
    - Link against the updated library from the libsrtp2-dev package which
      already has a fix of OpenSSL 3.0.0 incompatibility.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 07 May 2023 13:37:20 +0300

## libtgowt 0~git20230615.a45d8b8+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0091 NEW)
include(CMakeDependentOption)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

set(TG_OWT_SPECIAL_TARGET "" CACHE STRING "Use special platform target, like 'macstore' for Mac App Store.")

if (NOT TG_OWT_SPECIAL_TARGET STREQUAL "")
    set(TG_OWT_PACKAGED_BUILD 0)
else()
    set(TG_OWT_PACKAGED_BUILD 1)
endif()

set(not_packaged_build 0)
if (NOT TG_OWT_PACKAGED_BUILD)
    set(not_packaged_build 1)
    set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12 CACHE STRING "Minimum OS X deployment version" FORCE)
endif()

option(BUILD_SHARED_LIBS "Builds shared libraries instead of static." OFF)
option(TG_OWT_USE_PROTOBUF "Use protobuf to generate additional headers. Useful for packaged build." ${BUILD_SHARED_LIBS})
cmake_dependent_option(TG_OWT_USE_X11 "Use X11 for desktop capture." ON "UNIX; NOT APPLE" OFF)
cmake_dependent_option(TG_OWT_USE_PIPEWIRE "Use pipewire for desktop capture." ON "UNIX; NOT APPLE" OFF)
cmake_dependent_option(TG_OWT_DLOPEN_PIPEWIRE "dlopen pipewire for desktop capture." ${not_packaged_build} TG_OWT_USE_PIPEWIRE OFF)
option(TG_OWT_BUILD_AUDIO_BACKENDS "Build webrtc audio backends." OFF)

if (BUILD_SHARED_LIBS)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    message(WARNING
        "tg_owt is a fork of Google's webrtc library and is developed by them as a static library without stable ABI in mind."
        "The feature of building tg_owt as a shared library is community maintained, it may and will break at any time without guarantee to work again."
        "Please reconsider your decision. Good luck."
    )
endif()

if (TG_OWT_BUILD_AUDIO_BACKENDS)
    message(WARNING
        "According to upstream WebRTC developers, audio backends for desktop platforms are only for demo purposes."
        "It's not recommended to use them. You've been warned."
        "https://bugs.chromium.org/p/webrtc/issues/detail?id=10537#c2"
        "https://bugs.chromium.org/p/webrtc/issues/detail?id=10622#c3"
    )
endif()

project(tg_owt
    LANGUAGES C CXX ASM
    DESCRIPTION "WebRTC build for Telegram"
    HOMEPAGE_URL "https://github.com/desktop-app/tg_owt.git"
)
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT tg_owt)

get_filename_component(webrtc_loc "src" REALPATH)
set(third_party_loc ${webrtc_loc}/third_party)
set(tools_loc ${webrtc_loc}/tools)

include(GNUInstallDirs)
set(webrtc_includedir ${CMAKE_INSTALL_INCLUDEDIR}/tg_owt)

if (CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
    set(is_aarch64 1)
    set(arm_use_neon 1)
else()
    if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
        set(is_x64 1)
    else()
        include(cmake/arch.cmake)
    endif()
endif()

include(cmake/nice_target_sources.cmake)
include(cmake/init_target.cmake)
include(cmake/generate_target.cmake)
include(cmake/target_yasm_sources.cmake)
include(cmake/external.cmake)
include(cmake/libabsl.cmake)
include(cmake/libcrc32c.cmake)
include(cmake/libopenh264.cmake)
include(cmake/libpffft.cmake)
include(cmake/librnnoise.cmake)
include(cmake/libsrtp.cmake)
include(cmake/libyuv.cmake)
if (APPLE)
    include(cmake/libsdkmacos.cmake)
endif()

# Use a separate subdirectory, because it will be exported as an INTERFACE
# for the generated sources and headers.
if (TG_OWT_USE_PROTOBUF)
    add_subdirectory(cmake/protobuf)
endif()

add_library(tg_owt)
init_target(tg_owt)

if (TG_OWT_USE_PIPEWIRE)
    if (TG_OWT_DLOPEN_PIPEWIRE)
        include(cmake/generate_stubs.cmake)
        set(stubs_loc ${webrtc_loc}/modules/desktop_capture/linux/wayland)
        generate_stubs(tg_owt
            ${stubs_loc}/pipewire_stub_header.fragment
            pipewire_stubs
            ${stubs_loc}/pipewire.sigs
        )
        target_compile_definitions(tg_owt
        PRIVATE
            WEBRTC_DLOPEN_PIPEWIRE
        )

        target_include_directories(tg_owt
        PRIVATE
            ${webrtc_loc}/third_party/pipewire/spa/include
            ${webrtc_loc}/third_party/pipewire/src
            ${webrtc_loc}/third_party/pipewire/build/src
        )
    endif()

    link_glib(tg_owt)
    link_pipewire(tg_owt ${TG_OWT_DLOPEN_PIPEWIRE})

    find_package(PkgConfig REQUIRED)
    pkg_check_modules(GBM REQUIRED gbm)
    pkg_check_modules(DRM REQUIRED libdrm)
    pkg_check_modules(GL REQUIRED gl)
    pkg_check_modules(EGL REQUIRED egl)

    target_include_directories(tg_owt SYSTEM
    PRIVATE
        ${GBM_INCLUDE_DIRS}
        ${DRM_INCLUDE_DIRS}
        ${GL_INCLUDE_DIRS}
        ${EGL_INCLUDE_DIRS}
    )
endif()

set_target_properties(tg_owt PROPERTIES SOVERSION 0 VERSION 0.0.0)

target_link_libraries(tg_owt
PRIVATE
    tg_owt::libpffft
    tg_owt::librnnoise
    tg_owt::libsrtp
    tg_owt::libyuv
)

if (is_x86 OR is_x64)
    target_link_libraries(tg_owt
    PRIVATE
        tg_owt::tg_owt_avx2
        tg_owt::tg_owt_sse2
    )
endif()

if (TG_OWT_USE_PROTOBUF)
    target_link_libraries(tg_owt
    PRIVATE
        tg_owt::proto
    )
endif()

target_sources(tg_owt
PRIVATE
    ${libvpx_yasm_objects}
    ${libopenh264_yasm_objects}
)

if (APPLE)
    target_link_libraries(tg_owt PUBLIC tg_owt::libsdkmacos)
endif()

link_openssl(tg_owt)
link_ffmpeg(tg_owt)
link_opus(tg_owt)
link_libabsl(tg_owt)
link_libopenh264(tg_owt)
link_libvpx(tg_owt)
link_crc32c(tg_owt)

if (TG_OWT_BUILD_AUDIO_BACKENDS AND (UNIX AND NOT APPLE))
    link_libalsa(tg_owt)
    link_libpulse(tg_owt)
    link_dl(tg_owt)
endif()

include(cmake/libwebrtcbuild.cmake)
target_link_libraries(tg_owt PUBLIC tg_owt::libwebrtcbuild)

if (TG_OWT_USE_X11)
    link_x11(tg_owt)
endif()

function(add_sublibrary postfix)
    add_library(tg_owt_${postfix} OBJECT)
    init_feature_target(tg_owt_${postfix} ${postfix})
    add_library(tg_owt::tg_owt_${postfix} ALIAS tg_owt_${postfix})
    target_link_libraries(tg_owt_${postfix}
    PUBLIC
        tg_owt::libwebrtcbuild
    )
    link_libabsl(tg_owt_${postfix})
    target_include_directories(tg_owt_${postfix}
    PUBLIC
        $<BUILD_INTERFACE:${webrtc_loc}>
        $<INSTALL_INTERFACE:${webrtc_includedir}>
    )
    set(sources_list ${ARGV})
    list(REMOVE_AT sources_list 0)
    nice_target_sources(tg_owt_${postfix} ${webrtc_loc}
    PRIVATE
        ${sources_list}
    )
endfunction()

nice_target_sources(tg_owt ${webrtc_loc}
PRIVATE
    rtc_base/deprecated/recursive_critical_section.cc
    rtc_base/deprecated/recursive_critical_section.h
    rtc_base/async_packet_socket.cc
    rtc_base/async_packet_socket.h
    rtc_base/async_resolver_interface.cc
    rtc_base/async_resolver_interface.h
    rtc_base/async_resolver.cc
    rtc_base/async_resolver.h
    rtc_base/async_socket.cc
    rtc_base/async_socket.h
    rtc_base/async_tcp_socket.cc
    rtc_base/async_tcp_socket.h
    rtc_base/async_udp_socket.cc
    rtc_base/async_udp_socket.h
    rtc_base/callback_list.cc
    rtc_base/callback_list.h
    rtc_base/crc32.cc
    rtc_base/crc32.h
    rtc_base/crypt_string.cc
    rtc_base/crypt_string.h
    rtc_base/checks.cc
    rtc_base/checks.h
    rtc_base/data_rate_limiter.cc
    rtc_base/data_rate_limiter.h
    rtc_base/dscp.h
    rtc_base/file_rotating_stream.cc
    rtc_base/file_rotating_stream.h
    rtc_base/helpers.cc
    rtc_base/helpers.h
    rtc_base/http_common.cc
    rtc_base/http_common.h
    rtc_base/ip_address.cc
    rtc_base/ip_address.h
    rtc_base/logging.cc
    rtc_base/logging.h
    rtc_base/mdns_responder_interface.h
    rtc_base/memory/aligned_malloc.cc
    rtc_base/memory/aligned_malloc.h
    rtc_base/memory/fifo_buffer.cc
    rtc_base/memory/fifo_buffer.h
    rtc_base/memory/always_valid_pointer.h
    rtc_base/message_digest.cc
    rtc_base/message_digest.h
    rtc_base/net_helper.cc
    rtc_base/net_helper.h
    rtc_base/net_helpers.cc
    rtc_base/net_helpers.h
    rtc_base/network/sent_packet.cc
    rtc_base/network/sent_packet.h
    rtc_base/network.cc
    rtc_base/network_route.cc
    rtc_base/network.h
    rtc_base/network_constants.cc
    rtc_base/network_constants.h
    rtc_base/network_monitor.cc
    rtc_base/network_monitor.h
    rtc_base/network_route.h
    rtc_base/null_socket_server.cc
    rtc_base/null_socket_server.h
    rtc_base/platform_thread.cc
    rtc_base/platform_thread.h
    rtc_base/platform_thread_types.cc
    rtc_base/platform_thread_types.h
    rtc_base/operations_chain.cc
    rtc_base/operations_chain.h
    rtc_base/openssl.h
    rtc_base/openssl_adapter.cc
    rtc_base/openssl_adapter.h
    rtc_base/openssl_certificate.cc
    rtc_base/openssl_certificate.h
    rtc_base/openssl_digest.cc
    rtc_base/openssl_digest.h
    rtc_base/openssl_identity.cc
    rtc_base/openssl_identity.h
    rtc_base/openssl_key_pair.cc
    rtc_base/openssl_key_pair.h
    rtc_base/openssl_session_cache.cc
    rtc_base/openssl_session_cache.h
    rtc_base/openssl_stream_adapter.cc
    rtc_base/openssl_stream_adapter.h
    rtc_base/openssl_utility.cc
    rtc_base/openssl_utility.h
    rtc_base/physical_socket_server.cc
    rtc_base/physical_socket_server.h
    rtc_base/proxy_info.cc
    rtc_base/proxy_info.h
    rtc_base/rtc_certificate.cc
    rtc_base/rtc_certificate.h
    rtc_base/rtc_certificate_generator.cc
    rtc_base/rtc_certificate_generator.h
    rtc_base/rate_limiter.cc
    rtc_base/rate_limiter.h
    rtc_base/socket.cc
    rtc_base/socket.h
    rtc_base/socket_adapters.cc
    rtc_base/socket_adapters.h
    rtc_base/socket_address.cc
    rtc_base/socket_address.h
    rtc_base/socket_address_pair.cc
    rtc_base/socket_address_pair.h
    rtc_base/socket_factory.h
    rtc_base/socket_server.h
    rtc_base/ssl_adapter.cc
    rtc_base/ssl_adapter.h
    rtc_base/ssl_certificate.cc
    rtc_base/ssl_certificate.h
    rtc_base/ssl_fingerprint.cc
    rtc_base/ssl_fingerprint.h
    rtc_base/ssl_identity.cc
    rtc_base/ssl_identity.h
    rtc_base/ssl_stream_adapter.cc
    rtc_base/ssl_stream_adapter.h
    rtc_base/stream.cc
    rtc_base/stream.h
    rtc_base/time_utils.cc
    rtc_base/time_utils.h
    rtc_base/thread.cc
    rtc_base/thread.h
    rtc_base/unique_id_generator.cc
    rtc_base/unique_id_generator.h
    rtc_base/bit_buffer.cc
    rtc_base/bit_buffer.h
    rtc_base/bitstream_reader.cc
    rtc_base/bitstream_reader.h
    rtc_base/buffer.h
    rtc_base/buffer_queue.cc
    rtc_base/buffer_queue.h
    rtc_base/byte_buffer.cc
    rtc_base/byte_buffer.h
    rtc_base/byte_order.h
    rtc_base/copy_on_write_buffer.cc
    rtc_base/copy_on_write_buffer.h
    rtc_base/event.cc
    rtc_base/event.h
    rtc_base/event_tracer.cc
    rtc_base/event_tracer.h
    rtc_base/numerics/histogram_percentile_counter.cc
    rtc_base/numerics/histogram_percentile_counter.h
    rtc_base/numerics/mod_ops.h
    rtc_base/numerics/moving_max_counter.h
    rtc_base/numerics/moving_percentile_filter.h
    rtc_base/numerics/sample_counter.cc
    rtc_base/numerics/sample_counter.h
    rtc_base/one_time_event.h
    rtc_base/race_checker.cc
    rtc_base/race_checker.h
    rtc_base/random.cc
    rtc_base/random.h
    rtc_base/rate_statistics.cc
    rtc_base/rate_statistics.h
    rtc_base/rate_tracker.cc
    rtc_base/rate_tracker.h
    rtc_base/swap_queue.h
    rtc_base/timestamp_aligner.cc
    rtc_base/timestamp_aligner.h
    rtc_base/trace_event.h
    rtc_base/zero_memory.cc
    rtc_base/zero_memory.h
    rtc_base/string_encode.cc
    rtc_base/string_encode.h
    rtc_base/string_to_number.cc
    rtc_base/string_to_number.h
    rtc_base/string_utils.cc
    rtc_base/string_utils.h
    rtc_base/weak_ptr.cc
    rtc_base/weak_ptr.h
    rtc_base/win32.cc
    rtc_base/win32.h
    rtc_base/win32_window.cc
    rtc_base/win32_window.h
    rtc_base/containers/flat_map.h
    rtc_base/containers/flat_set.h
    rtc_base/containers/flat_tree.cc
    rtc_base/containers/flat_tree.h
    rtc_base/containers/identity.h
    rtc_base/containers/invoke.h
    rtc_base/containers/move_only_int.h
    rtc_base/win/scoped_com_initializer.cc
    rtc_base/win/scoped_com_initializer.h
    rtc_base/win/windows_version.cc
    rtc_base/win/windows_version.h

=== src/third_party/libyuv/CMakeLists.txt ===
# CMakeLists for libyuv
# Originally created for "roxlu build system" to compile libyuv on windows
# Run with -DTEST=ON to build unit tests

PROJECT ( YUV C CXX )	# "C" is required even for C++ projects
CMAKE_MINIMUM_REQUIRED( VERSION 2.8.12 )
OPTION( TEST "Built unit tests" OFF )

SET ( ly_base_dir	${PROJECT_SOURCE_DIR} )
SET ( ly_src_dir	${ly_base_dir}/source )
SET ( ly_inc_dir	${ly_base_dir}/include )
SET ( ly_tst_dir	${ly_base_dir}/unit_test )
SET ( ly_lib_name	yuv )
SET ( ly_lib_static	${ly_lib_name} )
SET ( ly_lib_shared	${ly_lib_name}_shared )

FILE ( GLOB_RECURSE	ly_source_files ${ly_src_dir}/*.cc )
LIST ( SORT			ly_source_files )

FILE ( GLOB_RECURSE	ly_unittest_sources ${ly_tst_dir}/*.cc )
LIST ( SORT			ly_unittest_sources )

INCLUDE_DIRECTORIES( BEFORE ${ly_inc_dir} )

if(MSVC)
  ADD_DEFINITIONS ( -D_CRT_SECURE_NO_WARNINGS )
endif()

# this creates the static library (.a)
ADD_LIBRARY				( ${ly_lib_static} STATIC ${ly_source_files} )

# this creates the shared library (.so)
ADD_LIBRARY				( ${ly_lib_shared} SHARED ${ly_source_files} )
SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES OUTPUT_NAME "${ly_lib_name}" )
SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES PREFIX "lib" )
if(WIN32)
  SET_TARGET_PROPERTIES	( ${ly_lib_shared} PROPERTIES IMPORT_PREFIX "lib" )
endif()

# this creates the conversion tool
ADD_EXECUTABLE			( yuvconvert ${ly_base_dir}/util/yuvconvert.cc )
TARGET_LINK_LIBRARIES	( yuvconvert ${ly_lib_static} )

# this creates the yuvconstants tool
ADD_EXECUTABLE      ( yuvconstants ${ly_base_dir}/util/yuvconstants.c )
TARGET_LINK_LIBRARIES  ( yuvconstants ${ly_lib_static} )

find_package ( JPEG )
if (JPEG_FOUND)
  include_directories( ${JPEG_INCLUDE_DIR} )
  target_link_libraries( ${ly_lib_shared} ${JPEG_LIBRARY} )
  add_definitions( -DHAVE_JPEG )
endif()

if(TEST)
  if (NOT CMAKE_CROSSCOMPILING)
    find_library(GTEST_LIBRARY gtest)
    if(GTEST_LIBRARY STREQUAL "GTEST_LIBRARY-NOTFOUND")
      set(GTEST_SRC_DIR /usr/src/gtest CACHE STRING "Location of gtest sources")
      if(EXISTS ${GTEST_SRC_DIR}/src/gtest-all.cc)
        message(STATUS "building gtest from sources in ${GTEST_SRC_DIR}")
        set(gtest_sources ${GTEST_SRC_DIR}/src/gtest-all.cc)
        add_library(gtest STATIC ${gtest_sources})
        include_directories(${GTEST_SRC_DIR})
        include_directories(${GTEST_SRC_DIR}/include)
        set(GTEST_LIBRARY gtest)
      else()
        message(FATAL_ERROR "TEST is set but unable to find gtest library")
      endif()
    endif()
  else()
    add_subdirectory(third_party/googletest/src)
    set(GTEST_LIBRARY gtest)
  endif()

  add_executable(libyuv_unittest ${ly_unittest_sources})
  target_link_libraries(libyuv_unittest ${ly_lib_name} ${GTEST_LIBRARY})
  find_library(PTHREAD_LIBRARY pthread)
  if(NOT PTHREAD_LIBRARY STREQUAL "PTHREAD_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest pthread)
  endif()
  if (JPEG_FOUND)
    target_link_libraries(libyuv_unittest ${JPEG_LIBRARY})
  endif()

  if(NACL AND NACL_LIBC STREQUAL "newlib")
    target_link_libraries(libyuv_unittest glibc-compat)
  endif()

  find_library(GFLAGS_LIBRARY gflags)
  if(NOT GFLAGS_LIBRARY STREQUAL "GFLAGS_LIBRARY-NOTFOUND")
    target_link_libraries(libyuv_unittest gflags)
    add_definitions(-DLIBYUV_USE_GFLAGS)
  endif()
endif()


# install the conversion tool, .so, .a, and all the header files
INSTALL ( PROGRAMS ${CMAKE_BINARY_DIR}/yuvconvert			DESTINATION bin )
INSTALL ( TARGETS ${ly_lib_static}						DESTINATION lib )
INSTALL ( TARGETS ${ly_lib_shared} LIBRARY				DESTINATION lib RUNTIME DESTINATION bin )
INSTALL ( DIRECTORY ${PROJECT_SOURCE_DIR}/include/		DESTINATION include )

# create the .deb and .rpm packages using cpack
INCLUDE ( CM_linux_packages.cmake )

=== src/third_party/crc32c/src/CMakeLists.txt ===
# Copyright 2017 The CRC32C Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file. See the AUTHORS file for names of contributors.

cmake_minimum_required(VERSION 3.1)
project(Crc32c VERSION 1.1.0 LANGUAGES C CXX)

# C standard can be overridden when this is used as a sub-project.
if(NOT CMAKE_C_STANDARD)
  # This project can use C11, but will gracefully decay down to C89.
  set(CMAKE_C_STANDARD 11)
  set(CMAKE_C_STANDARD_REQUIRED OFF)
  set(CMAKE_C_EXTENSIONS OFF)
endif(NOT CMAKE_C_STANDARD)

# C++ standard can be overridden when this is used as a sub-project.
if(NOT CMAKE_CXX_STANDARD)
  # This project requires C++11.
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif(NOT CMAKE_CXX_STANDARD)

# https://github.com/izenecloud/cmake/blob/master/SetCompilerWarningAll.cmake
if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # Use the highest warning level for Visual Studio.
  set(CMAKE_CXX_WARNING_LEVEL 4)
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")

  # Disable C++ exceptions.
  string(REGEX REPLACE "/EH[a-z]+" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHs-c-")
  add_definitions(-D_HAS_EXCEPTIONS=0)

  # Disable RTTI.
  string(REGEX REPLACE "/GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-")
else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # Use -Wall for clang and gcc.
  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wall")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wall")

  # Use -Wextra for clang and gcc.
  if(NOT CMAKE_CXX_FLAGS MATCHES "-Wextra")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Wextra")

  # Use -Werror for clang and gcc.
  if(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
  endif(NOT CMAKE_CXX_FLAGS MATCHES "-Werror")

  # Disable C++ exceptions.
  string(REGEX REPLACE "-fexceptions" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")

  # Disable RTTI.
  string(REGEX REPLACE "-frtti" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")

option(CRC32C_BUILD_TESTS "Build CRC32C's unit tests" ON)
option(CRC32C_BUILD_BENCHMARKS "Build CRC32C's benchmarks" ON)
option(CRC32C_USE_GLOG "Build CRC32C's tests with Google Logging" ON)
option(CRC32C_INSTALL "Install CRC32C's header and library" ON)

include(TestBigEndian)
test_big_endian(BYTE_ORDER_BIG_ENDIAN)

include(CheckCXXCompilerFlag)
# Used by glog.
check_cxx_compiler_flag(-Wno-deprecated CRC32C_HAVE_NO_DEPRECATED)
# Used by glog.
check_cxx_compiler_flag(-Wno-sign-compare CRC32C_HAVE_NO_SIGN_COMPARE)
# Used by glog.
check_cxx_compiler_flag(-Wno-unused-parameter CRC32C_HAVE_NO_UNUSED_PARAMETER)
# Used by googletest.
check_cxx_compiler_flag(-Wno-missing-field-initializers
                        CRC32C_HAVE_NO_MISSING_FIELD_INITIALIZERS)

# Check for __builtin_prefetch support in the compiler.
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
int main() {
  char data = 0;
  const char* address = &data;
  __builtin_prefetch(address, 0, 0);
  return 0;
}
"  HAVE_BUILTIN_PREFETCH)

# Check for _mm_prefetch support in the compiler.
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
#if defined(_MSC_VER)
#include <intrin.h>
#else  // !defined(_MSC_VER)
#include <xmmintrin.h>
#endif  // defined(_MSC_VER)

int main() {
  char data = 0;
  const char* address = &data;
  _mm_prefetch(address, _MM_HINT_NTA);
  return 0;
}
"  HAVE_MM_PREFETCH)

# Check for SSE4.2 support in the compiler.
set(OLD_CMAKE_REQURED_FLAGS ${CMAKE_REQUIRED_FLAGS})
if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} /arch:AVX")
else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -msse4.2")
endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
check_cxx_source_compiles("
#if defined(_MSC_VER)
#include <intrin.h>
#else  // !defined(_MSC_VER)
#include <cpuid.h>
#include <nmmintrin.h>
#endif  // defined(_MSC_VER)

int main() {
  _mm_crc32_u8(0, 0); _mm_crc32_u32(0, 0);
#if defined(_M_X64) || defined(__x86_64__)
   _mm_crc32_u64(0, 0);
#endif // defined(_M_X64) || defined(__x86_64__)
  return 0;
}
"  HAVE_SSE42)
set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})

# Check for ARMv8 w/ CRC and CRYPTO extensions support in the compiler.
set(OLD_CMAKE_REQURED_FLAGS ${CMAKE_REQUIRED_FLAGS})
if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # TODO(pwnall): Insert correct flag when VS gets ARM CRC32C support.
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} /arch:NOTYET")
else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -march=armv8-a+crc+crypto")
endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
check_cxx_source_compiles("
#include <arm_acle.h>
#include <arm_neon.h>

int main() {
  __crc32cb(0, 0); __crc32ch(0, 0); __crc32cw(0, 0); __crc32cd(0, 0);
  vmull_p64(0, 0);
  return 0;
}
" HAVE_ARM64_CRC32C)
set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQURED_FLAGS})

# Check for strong getauxval() support in the system headers.
check_cxx_source_compiles("
#include <arm_acle.h>
#include <arm_neon.h>
#include <sys/auxv.h>

int main() {
  getauxval(AT_HWCAP);
  return 0;
}
" HAVE_STRONG_GETAUXVAL)

# Check for weak getauxval() support in the compiler.
check_cxx_source_compiles("
unsigned long getauxval(unsigned long type) __attribute__((weak));
#define AT_HWCAP 16

int main() {
  getauxval(AT_HWCAP);
  return 0;
}
" HAVE_WEAK_GETAUXVAL)

if(CRC32C_USE_GLOG)
  # glog requires this setting to avoid using dynamic_cast.
  set(DISABLE_RTTI ON CACHE BOOL "" FORCE)

  # glog's test targets trigger deprecation warnings, and compiling them burns
  # CPU cycles on the CI.
  set(BUILD_TESTING_SAVED "${BUILD_TESTING}")
  set(BUILD_TESTING OFF CACHE BOOL "" FORCE)
  add_subdirectory("third_party/glog" EXCLUDE_FROM_ALL)
  set(BUILD_TESTING "${BUILD_TESTING_SAVED}" CACHE BOOL "" FORCE)

  # glog triggers deprecation warnings on OSX.
  # https://github.com/google/glog/issues/185
  if(CRC32C_HAVE_NO_DEPRECATED)
    set_property(TARGET glog APPEND PROPERTY COMPILE_OPTIONS -Wno-deprecated)
  endif(CRC32C_HAVE_NO_DEPRECATED)

  # glog triggers sign comparison warnings on gcc.
  if(CRC32C_HAVE_NO_SIGN_COMPARE)
    set_property(TARGET glog APPEND PROPERTY COMPILE_OPTIONS -Wno-sign-compare)
  endif(CRC32C_HAVE_NO_SIGN_COMPARE)

  # glog triggers unused parameter warnings on clang.
  if(CRC32C_HAVE_NO_UNUSED_PARAMETER)
    set_property(TARGET glog
                 APPEND PROPERTY COMPILE_OPTIONS -Wno-unused-parameter)
  endif(CRC32C_HAVE_NO_UNUSED_PARAMETER)

  set(CRC32C_TESTS_BUILT_WITH_GLOG 1)
endif(CRC32C_USE_GLOG)

configure_file(
  "src/crc32c_config.h.in"
  "${PROJECT_BINARY_DIR}/include/crc32c/crc32c_config.h"
)

include_directories("${PROJECT_BINARY_DIR}/include")

# ARM64 CRC32C code is built separately, so we don't accidentally compile
# unsupported instructions into code that gets run without ARM32 support.
add_library(crc32c_arm64 OBJECT "")
target_sources(crc32c_arm64
  PRIVATE
    "${PROJECT_BINARY_DIR}/include/crc32c/crc32c_config.h"
    "src/crc32c_arm64.cc"
    "src/crc32c_arm64.h"
)
if(HAVE_ARM64_CRC32C)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    # TODO(pwnall): Insert correct flag when VS gets ARM64 CRC32C support.
    target_compile_options(crc32c_arm64 PRIVATE "/arch:NOTYET")
  else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(crc32c_arm64 PRIVATE "-march=armv8-a+crc+crypto")
  endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
endif(HAVE_ARM64_CRC32C)

# CMake only enables PIC by default in SHARED and MODULE targets.
if(BUILD_SHARED_LIBS)
  set_property(TARGET crc32c_arm64 PROPERTY POSITION_INDEPENDENT_CODE TRUE)
endif(BUILD_SHARED_LIBS)

# SSE4.2 code is built separately, so we don't accidentally compile unsupported
# instructions into code that gets run without SSE4.2 support.
add_library(crc32c_sse42 OBJECT "")
target_sources(crc32c_sse42
  PRIVATE
    "${PROJECT_BINARY_DIR}/include/crc32c/crc32c_config.h"
    "src/crc32c_sse42.cc"
    "src/crc32c_sse42.h"
)
if(HAVE_SSE42)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(crc32c_sse42 PRIVATE "/arch:AVX")
  else(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(crc32c_sse42 PRIVATE "-msse4.2")
  endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
endif(HAVE_SSE42)

# CMake only enables PIC by default in SHARED and MODULE targets.
if(BUILD_SHARED_LIBS)
  set_property(TARGET crc32c_sse42 PROPERTY POSITION_INDEPENDENT_CODE TRUE)
endif(BUILD_SHARED_LIBS)

# Must be included before CMAKE_INSTALL_INCLUDEDIR is used.
include(GNUInstallDirs)

add_library(crc32c ""
  # TODO(pwnall): Move the TARGET_OBJECTS generator expressions to the PRIVATE
  # section of target_sources when cmake_minimum_required becomes 3.9 or above.
  $<TARGET_OBJECTS:crc32c_arm64>
  $<TARGET_OBJECTS:crc32c_sse42>
)
target_sources(crc32c
  PRIVATE
    "${PROJECT_BINARY_DIR}/include/crc32c/crc32c_config.h"
    "src/crc32c_arm64.h"
    "src/crc32c_arm64_check.h"
    "src/crc32c_internal.h"
    "src/crc32c_portable.cc"
    "src/crc32c_prefetch.h"
    "src/crc32c_read_le.h"
    "src/crc32c_round_up.h"
    "src/crc32c_sse42.h"
    "src/crc32c_sse42_check.h"
    "src/crc32c.cc"

  # Only CMake 3.3+ supports PUBLIC sources in targets exported by "install".
  $<$<VERSION_GREATER:CMAKE_VERSION,3.2>:PUBLIC>
    "include/crc32c/crc32c.h"
)

target_include_directories(crc32c
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(crc32c
  PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

# Warnings as errors in Visual Studio for this project's targets.
if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  set_property(TARGET crc32c APPEND PROPERTY COMPILE_OPTIONS "/WX")
  set_property(TARGET crc32c_arm64 APPEND PROPERTY COMPILE_OPTIONS "/WX")
  set_property(TARGET crc32c_sse42 APPEND PROPERTY COMPILE_OPTIONS "/WX")
endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")

if(CRC32C_BUILD_TESTS)
  enable_testing()

  # Prevent overriding the parent project's compiler/linker settings on Windows.
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  set(install_gtest OFF)
  set(install_gmock OFF)

  # This project is tested using GoogleTest.
  add_subdirectory("third_party/googletest")

  # GoogleTest triggers a missing field initializers warning.
  if(CRC32C_HAVE_NO_MISSING_FIELD_INITIALIZERS)
    set_property(TARGET gtest
        APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
    set_property(TARGET gmock
        APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
  endif(CRC32C_HAVE_NO_MISSING_FIELD_INITIALIZERS)

  add_executable(crc32c_tests "")
  target_sources(crc32c_tests
    PRIVATE
      "${PROJECT_BINARY_DIR}/include/crc32c/crc32c_config.h"
      "src/crc32c_arm64_unittest.cc"
      "src/crc32c_extend_unittests.h"
      "src/crc32c_portable_unittest.cc"
      "src/crc32c_prefetch_unittest.cc"
      "src/crc32c_read_le_unittest.cc"
      "src/crc32c_round_up_unittest.cc"
      "src/crc32c_sse42_unittest.cc"
      "src/crc32c_unittest.cc"
      "src/crc32c_test_main.cc"
  )
  target_link_libraries(crc32c_tests crc32c gtest)

  # Warnings as errors in Visual Studio for this project's targets.
  if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set_property(TARGET crc32c_tests APPEND PROPERTY COMPILE_OPTIONS "/WX")
  endif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")

  if(CRC32C_USE_GLOG)

=== src/third_party/openh264/src/Makefile ===
SRC_PATH=$(word 1, $(dir $(MAKEFILE_LIST)))
vpath %.c $(SRC_PATH)
vpath %.cc $(SRC_PATH)
vpath %.cpp $(SRC_PATH)
vpath %.asm $(SRC_PATH)
vpath %.S $(SRC_PATH)
vpath %.rc $(SRC_PATH)
vpath %.pc.in $(SRC_PATH)

OS=$(shell uname | tr A-Z a-z | tr -d \\-0-9. | sed -E 's/^(net|open|free)bsd/bsd/')
ARCH=$(shell uname -m)
LIBPREFIX=lib
LIBSUFFIX=a
CCAS=$(CC)
CXX_O=-o $@
CXX_LINK_O=-o $@
AR_OPTS=cr $@
LINK_LOCAL_DIR=-L.
LINK_LIB=-l$(1)
CFLAGS_OPT=-O3
CFLAGS_DEBUG=-g
BUILDTYPE=Release
V=Yes
PREFIX=/usr/local
SHARED=-shared
OBJ=o
DESTDIR=
LIBDIR_NAME=lib
SHAREDLIB_DIR=$(PREFIX)/lib
PROJECT_NAME=openh264
MODULE_NAME=gmpopenh264
GMP_API_BRANCH=Firefox39
GTEST_VER=release-1.8.1
CCASFLAGS=$(CFLAGS)
STATIC_LDFLAGS=-lstdc++
STRIP ?= strip

SHAREDLIB_MAJORVERSION=5
FULL_VERSION := 1.9.0

ifeq (,$(wildcard $(SRC_PATH)gmp-api))
HAVE_GMP_API=No
else
HAVE_GMP_API=Yes
endif

ifeq (,$(wildcard $(SRC_PATH)gtest))
HAVE_GTEST=No
else
HAVE_GTEST=Yes
endif

# Configurations
ifeq ($(BUILDTYPE), Release)
CFLAGS += $(CFLAGS_OPT)
CFLAGS += -DNDEBUG
USE_ASM = Yes
ifeq ($(DEBUGSYMBOLS), True)
CFLAGS += -g
CXXFLAGS += -g
DEBUGSYMBOLS_TAG := _debug_symbols
PROCESS_FILES := True
endif
else
CFLAGS += $(CFLAGS_DEBUG)
USE_ASM = No
endif

ifeq ($(USE_ASAN), Yes)
CFLAGS += -fsanitize=address
LDFLAGS += -fsanitize=address
endif

STRIP_FLAGS := -S
ifeq (linux, $((OS)))
STRIP_FLAGS := -g
endif

# Make sure the all target is the first one
all: libraries binaries

include $(SRC_PATH)build/platform-$(OS).mk

MODULE := $(LIBPREFIX)$(MODULE_NAME).$(SHAREDLIBSUFFIX)

CFLAGS += -DGENERATED_VERSION_HEADER
LDFLAGS +=

ifeq (Yes, $(GCOV))
CFLAGS += -fprofile-arcs -ftest-coverage
LDFLAGS += -lgcov
endif

#### No user-serviceable parts below this line
ifneq ($(V),Yes)
    QUIET_CXX  = @printf "CXX\t$@\n";
    QUIET_CC   = @printf "CC\t$@\n";
    QUIET_CCAS = @printf "CCAS\t$@\n";
    QUIET_ASM  = @printf "ASM\t$@\n";
    QUIET_AR   = @printf "AR\t$@\n";
    QUIET_RC   = @printf "RC\t$@\n";
    QUIET      = @
endif


INCLUDES += -I$(SRC_PATH)codec/api/svc -I$(SRC_PATH)codec/common/inc -Icodec/common/inc

DECODER_INCLUDES += \
    -I$(SRC_PATH)codec/decoder/core/inc \
    -I$(SRC_PATH)codec/decoder/plus/inc

ENCODER_INCLUDES += \
    -I$(SRC_PATH)codec/encoder/core/inc \
    -I$(SRC_PATH)codec/encoder/plus/inc \
    -I$(SRC_PATH)codec/processing/interface

PROCESSING_INCLUDES += \
    -I$(SRC_PATH)codec/processing/interface \
    -I$(SRC_PATH)codec/processing/src/common \
    -I$(SRC_PATH)codec/processing/src/adaptivequantization \
    -I$(SRC_PATH)codec/processing/src/downsample \
    -I$(SRC_PATH)codec/processing/src/scrolldetection \
    -I$(SRC_PATH)codec/processing/src/vaacalc

GTEST_INCLUDES += \
    -I$(SRC_PATH)gtest/googletest \
    -I$(SRC_PATH)gtest/googletest/include

CODEC_UNITTEST_INCLUDES += \
    -I$(SRC_PATH)gtest/googletest/include \
    -I$(SRC_PATH)codec/common/inc \
    -I$(SRC_PATH)test

CONSOLE_COMMON_INCLUDES += \
    -I$(SRC_PATH)codec/console/common/inc

H264DEC_INCLUDES += $(DECODER_INCLUDES) $(CONSOLE_COMMON_INCLUDES) -I$(SRC_PATH)codec/console/dec/inc
H264DEC_LDFLAGS = $(LINK_LOCAL_DIR) $(call LINK_LIB,decoder) $(call LINK_LIB,common) $(call LINK_LIB,console_common)
H264DEC_DEPS = $(LIBPREFIX)decoder.$(LIBSUFFIX) $(LIBPREFIX)common.$(LIBSUFFIX) $(LIBPREFIX)console_common.$(LIBSUFFIX)

H264ENC_INCLUDES += $(ENCODER_INCLUDES) $(CONSOLE_COMMON_INCLUDES) -I$(SRC_PATH)codec/console/enc/inc
H264ENC_LDFLAGS = $(LINK_LOCAL_DIR) $(call LINK_LIB,encoder) $(call LINK_LIB,processing) $(call LINK_LIB,common) $(call LINK_LIB,console_common)
H264ENC_DEPS = $(LIBPREFIX)encoder.$(LIBSUFFIX) $(LIBPREFIX)processing.$(LIBSUFFIX) $(LIBPREFIX)common.$(LIBSUFFIX) $(LIBPREFIX)console_common.$(LIBSUFFIX)

CODEC_UNITTEST_LDFLAGS = $(LINK_LOCAL_DIR) $(call LINK_LIB,gtest) $(call LINK_LIB,decoder) $(call LINK_LIB,encoder) $(call LINK_LIB,processing) $(call LINK_LIB,common) $(CODEC_UNITTEST_LDFLAGS_SUFFIX)
CODEC_UNITTEST_DEPS = $(LIBPREFIX)gtest.$(LIBSUFFIX) $(LIBPREFIX)decoder.$(LIBSUFFIX) $(LIBPREFIX)encoder.$(LIBSUFFIX) $(LIBPREFIX)processing.$(LIBSUFFIX) $(LIBPREFIX)common.$(LIBSUFFIX)
DECODER_UNITTEST_INCLUDES += $(CODEC_UNITTEST_INCLUDES) $(DECODER_INCLUDES)
ENCODER_UNITTEST_INCLUDES += $(CODEC_UNITTEST_INCLUDES) $(ENCODER_INCLUDES)
PROCESSING_UNITTEST_INCLUDES += $(CODEC_UNITTEST_INCLUDES) $(PROCESSING_INCLUDES)
API_TEST_INCLUDES += $(CODEC_UNITTEST_INCLUDES)
COMMON_UNITTEST_INCLUDES += $(CODEC_UNITTEST_INCLUDES)
MODULE_INCLUDES += -I$(SRC_PATH)gmp-api

DECODER_UNITTEST_CFLAGS += $(CODEC_UNITTEST_CFLAGS)
ENCODER_UNITTEST_CFLAGS += $(CODEC_UNITTEST_CFLAGS)
PROCESSING_UNITTEST_CFLAGS += $(CODEC_UNITTEST_CFLAGS)
API_TEST_CFLAGS += $(CODEC_UNITTEST_CFLAGS)
COMMON_UNITTEST_CFLAGS += $(CODEC_UNITTEST_CFLAGS)

.PHONY: test gtest-bootstrap clean $(PROJECT_NAME).pc $(PROJECT_NAME)-static.pc

generate-version:
	$(QUIET)sh $(SRC_PATH)codec/common/generate_version.sh $(SRC_PATH)

codec/decoder/plus/src/welsDecoderExt.$(OBJ): | generate-version
codec/encoder/plus/src/welsEncoderExt.$(OBJ): | generate-version

clean:
ifeq (android,$(OS))
clean: clean_Android
endif
	$(QUIET)rm -f $(OBJS) $(OBJS:.$(OBJ)=.d) $(OBJS:.$(OBJ)=.obj) $(LIBRARIES) $(BINARIES) *.lib *.a *.dylib *.dll *.so *.so.* *.exe *.pdb *.exp *.pc *.res *.map $(SRC_PATH)codec/common/inc/version_gen.h

gmp-bootstrap:
	if [ ! -d gmp-api ] ; then git clone https://github.com/mozilla/gmp-api gmp-api ; fi
	cd gmp-api && git fetch origin && git checkout $(GMP_API_BRANCH)

gtest-bootstrap:
	if [ ! -d gtest ] ; then git clone https://github.com/google/googletest.git gtest && \
       cd gtest && git checkout -b $(GTEST_VER) $(GTEST_VER) ; fi

ifeq ($(HAVE_GTEST),Yes)

ifneq (android,$(OS))
ifneq (ios,$(OS))
ifneq (msvc-wp,$(OS))
BUILD_UT_EXE=Yes
endif
endif
endif

test: codec_unittest$(EXEEXT)
ifeq ($(BUILD_UT_EXE), Yes)
	./codec_unittest
endif

else
test:
	@echo "./gtest: No such file or directory."
	@echo "You do not have gtest. Run make gtest-bootstrap to get gtest"
endif

include $(SRC_PATH)codec/common/targets.mk
include $(SRC_PATH)codec/decoder/targets.mk
include $(SRC_PATH)codec/encoder/targets.mk
include $(SRC_PATH)codec/processing/targets.mk

ifeq ($(HAVE_GMP_API),Yes)
include $(SRC_PATH)module/targets.mk
endif

ifneq (android, $(OS))
ifneq (ios, $(OS))
ifneq (msvc-wp, $(OS))
include $(SRC_PATH)codec/console/dec/targets.mk
include $(SRC_PATH)codec/console/enc/targets.mk
include $(SRC_PATH)codec/console/common/targets.mk
endif
endif
endif

libraries: $(LIBPREFIX)$(PROJECT_NAME).$(LIBSUFFIX)

# No point in building dylib for ios
ifneq (ios, $(OS))
libraries: $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIX)
endif

LIBRARIES += $(LIBPREFIX)$(PROJECT_NAME).$(LIBSUFFIX) $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXFULLVER)

$(LIBPREFIX)$(PROJECT_NAME).$(LIBSUFFIX): $(ENCODER_OBJS) $(DECODER_OBJS) $(PROCESSING_OBJS) $(COMMON_OBJS)
	$(QUIET)rm -f $@
	$(QUIET_AR)$(AR) $(AR_OPTS) $+
ifeq (True, $(PROCESS_FILES))
	cp $@ $(LIBPREFIX)$(PROJECT_NAME)$(DEBUGSYMBOLS_TAG).$(LIBSUFFIX)
	$(STRIP) $(STRIP_FLAGS) $@ -o $@
endif

$(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXFULLVER): $(ENCODER_OBJS) $(DECODER_OBJS) $(PROCESSING_OBJS) $(COMMON_OBJS)
	$(QUIET)rm -f $@
	$(QUIET_CXX)$(CXX) $(SHARED) $(CXX_LINK_O) $+ $(LDFLAGS) $(SHLDFLAGS)
ifeq (True, $(PROCESS_FILES))
	cp $@ $(LIBPREFIX)$(PROJECT_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXFULLVER)
	$(STRIP) $(STRIP_FLAGS) $@ -o $@
endif

ifneq ($(SHAREDLIBSUFFIXFULLVER),$(SHAREDLIBSUFFIX))
$(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIX): $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXFULLVER)
	$(QUIET)ln -sfn $+ $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXMAJORVER)
	$(QUIET)ln -sfn $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXMAJORVER) $@
ifeq (True, $(PROCESS_FILES))
	$(QUIET)ln -sfn $(LIBPREFIX)$(PROJECT_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXFULLVER) $(LIBPREFIX)$(PROJECT_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXMAJORVER)
	$(QUIET)ln -sfn $(LIBPREFIX)$(PROJECT_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXMAJORVER) $(LIBPREFIX)$(PROJECT_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIX)
endif
endif

ifeq ($(HAVE_GMP_API),Yes)
plugin: $(MODULE)
LIBRARIES += $(LIBPREFIX)$(MODULE_NAME).$(SHAREDLIBSUFFIXFULLVER)
else
plugin:
	@echo "./gmp-api: No such file or directory."
	@echo "You do not have gmp-api.  Run make gmp-bootstrap to get the gmp-api headers."
endif

echo-plugin-name:
	@echo $(MODULE)

$(LIBPREFIX)$(MODULE_NAME).$(SHAREDLIBSUFFIXFULLVER): $(MODULE_OBJS) $(ENCODER_OBJS) $(DECODER_OBJS) $(PROCESSING_OBJS) $(COMMON_OBJS)
	$(QUIET)rm -f $@
	$(QUIET_CXX)$(CXX) $(SHARED) $(CXX_LINK_O) $+ $(LDFLAGS) $(SHLDFLAGS) $(MODULE_LDFLAGS)
ifeq (True, $(PROCESS_FILES))
	cp $@ $(LIBPREFIX)$(MODULE_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXFULLVER)
	$(STRIP) $(STRIP_FLAGS) $@ -o $@
endif

ifneq ($(SHAREDLIBSUFFIXFULLVER),$(SHAREDLIBSUFFIX))
$(MODULE): $(LIBPREFIX)$(MODULE_NAME).$(SHAREDLIBSUFFIXFULLVER)
	$(QUIET)ln -sfn $+ $(LIBPREFIX)$(MODULE_NAME).$(SHAREDLIBSUFFIXMAJORVER)
	$(QUIET)ln -sfn $(LIBPREFIX)$(MODULE_NAME).$(SHAREDLIBSUFFIXMAJORVER) $@
ifeq (True, $(PROCESS_FILES))
	$(QUIET)ln -sfn $(LIBPREFIX)$(MODULE_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXFULLVER) $(LIBPREFIX)$(MODULE_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXMAJORVER)
	$(QUIET)ln -sfn $(LIBPREFIX)$(MODULE_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIXMAJORVER) $(LIBPREFIX)$(MODULE_NAME)$(DEBUGSYMBOLS_TAG).$(SHAREDLIBSUFFIX)
endif
endif

$(PROJECT_NAME).pc: $(PROJECT_NAME).pc.in
	@sed -e 's;@prefix@;$(PREFIX);' -e 's;@VERSION@;$(FULL_VERSION);' -e 's;@LIBS@;;' -e 's;@LIBS_PRIVATE@;$(STATIC_LDFLAGS);' < $< > $@

$(PROJECT_NAME)-static.pc: $(PROJECT_NAME).pc.in
	@sed -e 's;@prefix@;$(PREFIX);' -e 's;@VERSION@;$(FULL_VERSION);' -e 's;@LIBS@;$(STATIC_LDFLAGS);' -e 's;@LIBS_PRIVATE@;;' < $< > $@

install-headers:
	mkdir -p $(DESTDIR)$(PREFIX)/include/wels
	install -m 644 $(SRC_PATH)/codec/api/svc/codec*.h $(DESTDIR)$(PREFIX)/include/wels

install-static-lib: $(LIBPREFIX)$(PROJECT_NAME).$(LIBSUFFIX) install-headers
	mkdir -p $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)
	install -m 644 $(LIBPREFIX)$(PROJECT_NAME).$(LIBSUFFIX) $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)

install-static: install-static-lib $(PROJECT_NAME)-static.pc
	mkdir -p $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)/pkgconfig
	install -m 644 $(PROJECT_NAME)-static.pc $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)/pkgconfig/$(PROJECT_NAME).pc

install-shared: $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIX) install-headers $(PROJECT_NAME).pc
	mkdir -p $(DESTDIR)$(SHAREDLIB_DIR)
	install -m 755 $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXFULLVER) $(DESTDIR)$(SHAREDLIB_DIR)
	if [ "$(SHAREDLIBSUFFIXFULLVER)" != "$(SHAREDLIBSUFFIX)" ]; then \
	  cp -a $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIXMAJORVER) $(DESTDIR)$(SHAREDLIB_DIR) ; \
	  cp -a $(LIBPREFIX)$(PROJECT_NAME).$(SHAREDLIBSUFFIX) $(DESTDIR)$(SHAREDLIB_DIR) ; \
	fi
	mkdir -p $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)/pkgconfig
	install -m 644 $(PROJECT_NAME).pc $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)/pkgconfig
ifneq ($(EXTRA_LIBRARY),)
	install -m 644 $(EXTRA_LIBRARY) $(DESTDIR)$(PREFIX)/$(LIBDIR_NAME)
endif

install: install-static-lib install-shared
	@:

ifneq ($(HAVE_GTEST),Yes)
binaries:
	@:
else
include $(SRC_PATH)build/gtest-targets.mk
include $(SRC_PATH)test/api/targets.mk
include $(SRC_PATH)test/decoder/targets.mk
include $(SRC_PATH)test/encoder/targets.mk
include $(SRC_PATH)test/processing/targets.mk
include $(SRC_PATH)test/common/targets.mk

LIBRARIES += $(LIBPREFIX)ut.$(LIBSUFFIX)
$(LIBPREFIX)ut.$(LIBSUFFIX): $(DECODER_UNITTEST_OBJS) $(ENCODER_UNITTEST_OBJS) $(PROCESSING_UNITTEST_OBJS) $(COMMON_UNITTEST_OBJS) $(API_TEST_OBJS)
	$(QUIET)rm -f $@
	$(QUIET_AR)$(AR) $(AR_OPTS) $+


LIBRARIES +=$(LIBPREFIX)ut.$(SHAREDLIBSUFFIX)
$(LIBPREFIX)ut.$(SHAREDLIBSUFFIX): $(DECODER_UNITTEST_OBJS) $(ENCODER_UNITTEST_OBJS) $(PROCESSING_UNITTEST_OBJS) $(API_TEST_OBJS) $(COMMON_UNITTEST_OBJS) $(CODEC_UNITTEST_DEPS)
	$(QUIET)rm -f $@
	$(QUIET_CXX)$(CXX) $(SHARED) $(CXX_LINK_O) $+ $(LDFLAGS) $(UTSHLDFLAGS) $(CODEC_UNITTEST_LDFLAGS)

=== debian/changelog ===
libtgowt (0~git20230615.a45d8b8+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix building with new ffmpeg (Closes: #1078287).

 -- Andrey Rakhmatullin <wrar@debian.org>  Wed, 11 Sep 2024 15:50:50 +0500

=== debian/control ===
Source: libtgowt
Priority: optional
Section: libs
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch:
 cmake (>= 3.16.0),
 libabsl-dev (>= 0~20220623.0),
 libasound2-dev,
 libavcodec-dev,
 libavformat-dev,
 libavutil-dev,
 libdrm-dev,
 libegl-dev,
 libgbm-dev,
 libgl-dev,
 libglib2.0-dev,
 libjpeg-dev,
 libopus-dev,
 libpipewire-0.3-dev,
 libprotobuf-dev,
 libpulse-dev,
 libsrtp2-dev,
 libssl-dev,
 libswresample-dev,
 libswscale-dev,
 libvpx-dev (>= 1.9.0),
 libxcomposite-dev,
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxrandr-dev,
 libxrender-dev,
 libxtst-dev,
 libyuv-dev,
 protobuf-compiler,
 python3:any,
 yasm [any-amd64 any-i386 x32],
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/desktop-app/tg_owt
Vcs-Git: https://salsa.debian.org/debian/libtgowt.git
Vcs-Browser: https://salsa.debian.org/debian/libtgowt

Package: libtgowt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libabsl-dev, ${misc:Depends}, ${static:Depends}
Description: telegram related WebRTC fork
 This supporting package contains a reduced fork of WebRTC source code. It is
 primarily needed for build support of video calls in Telegram Desktop. WebRTC
 project, in general, provides applications real-time capabilities that work on
 top of an open standard.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

%:
	dh $@

TEMP_DIR = debian/tmp
INSTALL_DIR = debian/libtgowt-dev
INCLUDE_DIR = $(INSTALL_DIR)/usr/include/tg_owt
FILES_EXCLUDED = $(patsubst %/*,%,$(shell grep-dctrl -n -s Files-Excluded . debian/copyright))

# We do build the static library which is advised by upstream. It is too
# difficult to guarantee binary compatibility of C++ code, and the library has
# only one dependent, Telegram Desktop client.
EXTRA_CMAKE_VARIABLES += TG_OWT_USE_PROTOBUF=ON TG_OWT_DLOPEN_PIPEWIRE=ON

ifeq ($(DEB_HOST_ARCH),armhf)
# WebRTC provides no runtime NEON checking, forbid unconditionally usage.
EXTRA_CMAKE_VARIABLES += TG_OWT_ARCH_ARMV7_USE_NEON=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

execute_after_dh_auto_install:
# Cut non UTF-8 bytes off to silence national-encoding Lintian warning. Regex taken from https://stackoverflow.com/a/1401716/5000805
	find $(INCLUDE_DIR) -type f -print0 | xargs -0 perl -pi -e 's/((?:[\x00-\x7F]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3}){1,100})|./$$1/g'
# Skip empty directories to fix package-contains-empty-directory Lintian info diagnostic.
	find $(INCLUDE_DIR) -empty -type d -delete
# Delete no longer used headers.
	$(RM) -r $(INCLUDE_DIR)/third_party/libyuv

# Collect all required packages for linking against the static library.
execute_before_dh_gencontrol:
	find $(INSTALL_DIR)/usr -name '*.cmake' | xargs grep -h -o '[^";]*\.so\>' | sort -u | xargs dpkg -S > debian/libtgowt-dev.deps
	echo static:Depends=$$(awk -F: '{print $$1 ","}' debian/libtgowt-dev.deps) >> debian/libtgowt-dev.substvars
ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
	column -t debian/libtgowt-dev.deps
endif

execute_after_dh_clean:
	$(RM) debian/libtgowt-dev.deps

# Download and repack original source code by hand because of uscan(1) does not
# support yet recursive cloning Git repositories. The next script additionally
# invokes tar(1) with options to generate reproducible tarball. You can install
# archiver tool from PyPI: https://pypi.org/project/git-archive-all/
get-orig-source:
	@trap 'rm -rf $(TEMP_DIR)' EXIT SIGINT ; set -e -u -x
	git clone --depth=1 https://github.com/desktop-app/tg_owt $(TEMP_DIR)/libtgowt.git
	git -C $(TEMP_DIR)/libtgowt.git submodule update --init --depth=1 $(addprefix :!,$(FILES_EXCLUDED))
	VERSION=`git -C $(TEMP_DIR)/libtgowt.git log -1 --format=0~git%cd.%h --date=format:%Y%m%d`
	MODIFIED=`git -C $(TEMP_DIR)/libtgowt.git log -1 --format=@%ct`
	git-archive-all -C $(TEMP_DIR)/libtgowt.git --prefix=libtgowt-$$VERSION/ $(TEMP_DIR)/libtgowt.tar
	tar -xf $(TEMP_DIR)/libtgowt.tar -C $(TEMP_DIR)
	rm -rf $(addprefix $(TEMP_DIR)/libtgowt-$$VERSION/,$(FILES_EXCLUDED))
	XZ_OPT='-T1' tar --sort=name --owner=root:0 --group=root:0 --mtime=$$MODIFIED -caf ../libtgowt_$$VERSION+dfsg.orig.tar.xz -C $(TEMP_DIR) libtgowt-$$VERSION

ifeq ($(MAKECMDGOALS),get-orig-source)
.ONESHELL:
endif
